/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
/*
 * Copyright (c) 2019 Ritsumeikan University
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation;
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Runs a random scenario with a traceroute application.
 * Requires the latest ns-3-dev version that includes the traceroute application.
 * check https://www.nsnam.org/ for more info.
 *
 * Authors: Alberto Gallegos Ramonet <ramonet@fc.ritsumei.ac.jp>
 *
 *
 */

#include "ns3/aodv-module.h"
#include "ns3/core-module.h"
#include "ns3/network-module.h"
#include "ns3/internet-module.h"
#include "ns3/mobility-module.h"
#include "ns3/point-to-point-module.h"
#include "ns3/wifi-module.h" 
#include "ns3/v4traceroute-helper.h"
#include "ns3/netanim-module.h"
#include <iostream>
#include <cmath>

using namespace ns3;

/**
 * This programs can trace the route to a give destinFation node
 * and its capable of generate a file of the trace as well as
 * a file with the positions of the nodes generated by the mobility
 * model
 */
class TraceRouteExample
{
public:
  TraceRouteExample ();
  /**
   * \brief Configure script parameters
   * \param argc is the command line argument count
   * \param argv is the command line arguments
   * \return true on successful configuration
  */
  bool Configure (int argc, char **argv);
  /// Run simulation
  void Run ();
  /**
   * Report results
   * \param os the output stream
   */
  void Report (std::ostream & os);

private:

  // parameters
  /// Number of nodes
  uint32_t size;
  /// Distance between nodes, meters
  double step;
  /// Simulation time, seconds
  double totalTime;
  /// Write per-device PCAP traces if true
  bool pcap;
  /// Print routes if true
  bool printRoutes;
  // The final node Ipv4 address of the trace
  std::string traceDst;

  /// nodes used in the example
  NodeContainer nodes;
  /// devices used in the example
  NetDeviceContainer devices;
  /// interfaces used in the example
  Ipv4InterfaceContainer interfaces;

private:
  /// Create the nodes
  void CreateNodes ();
  /// Create the devices
  void CreateDevices ();
  /// Create the network
  void InstallInternetStack ();
  /// Create the simulation applications
  void InstallApplications ();

  // Generetes a File with all the node positions
  void GetMobility(Ptr<OutputStreamWrapper> stream);

};


//-----------------------------------------------------------------------------
 TraceRouteExample::TraceRouteExample () :
  size (30),
  step (70),
  totalTime (300),
  pcap (false),
  printRoutes (false),
  traceDst("10.0.0.19")
{
}

bool
TraceRouteExample::Configure (int argc, char **argv)
{

  SeedManager::SetSeed (12345);
  CommandLine cmd;

  cmd.AddValue ("pcap", "Write PCAP traces.", pcap);
  cmd.AddValue ("printRoutes", "Print routing table dumps.", printRoutes);
  cmd.AddValue ("size", "Number of nodes.", size);
  cmd.AddValue ("time", "Simulation time, s.", totalTime);
  cmd.AddValue ("step", "Grid step, m", step);
  cmd.AddValue("traceDst","The last IpV4 address to which traceroute should trace",traceDst);

  cmd.Parse (argc, argv);
  return true;
}

void
TraceRouteExample::Run ()
{

  CreateNodes ();

  CreateDevices ();

  InstallInternetStack ();

  Ptr<OutputStreamWrapper> nodePositionStream = Create<OutputStreamWrapper> ("netNodePos", std::ios::out);
  GetMobility(nodePositionStream);

  InstallApplications ();

  //Print animation for NetAnim

  AnimationInterface anim ("traceRouteSample2Anim.xml");
  anim.EnablePacketMetadata ();
  anim.SetMobilityPollInterval(Seconds(0.1));
  for (int i=0; i<=size-1; i++)
   anim.UpdateNodeSize(i,3,3);

  anim.UpdateNodeColor(0,124,252,0);





  std::cout << "Starting simulation for " << totalTime << " s ...\n";

  Simulator::Stop (Seconds (totalTime));
  Simulator::Run ();
  Simulator::Destroy ();
}

void
TraceRouteExample::Report (std::ostream &)
{ 
}

void
TraceRouteExample::CreateNodes ()
{
  std::cout << "Creating " << (unsigned)size << " nodes.\n";
  nodes.Create (size);
  // Name nodes
  for (uint32_t i = 0; i < size; ++i)
    {
      std::ostringstream os;
      os << "node-" << i;
      Names::Add (os.str (), nodes.Get (i));
    }

 MobilityHelper mobility;
 /*
  mobility.SetPositionAllocator ("ns3::GridPositionAllocator",
                                 "MinX", DoubleValue (0.0),
                                 "MinY", DoubleValue (0.0),
                                 "DeltaX", DoubleValue (step),
                                 "DeltaY", DoubleValue (0),
                                 "GridWidth", UintegerValue (size),
                                 "LayoutType", StringValue ("RowFirst"));*/



 ///////////////////// Random positions in a Rectangle for nodes //////////////////////

  Ptr<UniformRandomVariable> x = CreateObject<UniformRandomVariable>();
  x->SetAttribute ("Min", DoubleValue (0));
  x->SetAttribute ("Max", DoubleValue (200));


  Ptr<UniformRandomVariable> y = CreateObject<UniformRandomVariable>();
  y->SetAttribute ("Min", DoubleValue (0));
  y->SetAttribute ("Max", DoubleValue (200));

  Ptr<RandomRectanglePositionAllocator> alloc =CreateObject<RandomRectanglePositionAllocator>();
  alloc->SetX (x);
  alloc->SetY (y);
  alloc->AssignStreams(4);
  /////////////////////////////////////////////////////////////////////////////////////////

  mobility.SetPositionAllocator (alloc);
  mobility.SetMobilityModel ("ns3::ConstantPositionMobilityModel");
  mobility.Install (nodes);


  //changing the position of the Root Node.
  Ptr<ConstantPositionMobilityModel> rootMobility;
  Vector rootPosition (100,100,0);
  rootMobility = nodes.Get(0)->GetObject<ConstantPositionMobilityModel> ();
  rootMobility->SetPosition(rootPosition);




}

void
TraceRouteExample::CreateDevices ()
{
  WifiMacHelper wifiMac;
  wifiMac.SetType ("ns3::AdhocWifiMac");
  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
  YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
  wifiChannel.AddPropagationLoss ("ns3::RangePropagationLossModel", "MaxRange", DoubleValue(50));
  wifiPhy.SetChannel (wifiChannel.Create ());

  WifiHelper wifi;
  wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", StringValue ("OfdmRate6Mbps"), "RtsCtsThreshold", UintegerValue (0));
  devices = wifi.Install (wifiPhy, wifiMac, nodes); 

  if (pcap)
    {
      wifiPhy.EnablePcapAll (std::string ("aodv"));
    }
}

void
TraceRouteExample::InstallInternetStack ()
{
  AodvHelper aodv;
  // you can configure AODV attributes here using aodv.Set(name, value)
  InternetStackHelper stack;
  stack.SetRoutingHelper (aodv); // has effect on the next Install ()
  stack.Install (nodes);
  Ipv4AddressHelper address;
  address.SetBase ("10.0.0.0", "255.0.0.0");
  interfaces = address.Assign (devices);

  if (printRoutes)
    {
      Ptr<OutputStreamWrapper> routingStream = Create<OutputStreamWrapper> ("aodv.routes", std::ios::out);
      aodv.PrintRoutingTableAllAt (Seconds (8), routingStream);

    }
}

void
TraceRouteExample::InstallApplications ()
{
  V4TraceRouteHelper traceroute (Ipv4Address(traceDst.c_str()));
  traceroute.SetAttribute ("Verbose", BooleanValue (true));

  ApplicationContainer p = traceroute.Install (nodes.Get (0));

  Ptr<OutputStreamWrapper> printstrm = Create<OutputStreamWrapper> ("netTraceRoutes", std::ios::app);
  traceroute.PrintTraceRouteAt(nodes.Get(0),printstrm);

  p.Start (Seconds (0));
  p.Stop (Seconds (totalTime) - Seconds (0.001));

}

void
TraceRouteExample::GetMobility (Ptr<OutputStreamWrapper> stream)
{
  Ipv4Address nodeIp;
  double x;
  double y;

  for (uint32_t i = 0; i < nodes.GetN(); ++i)
    {
	  nodeIp = nodes.Get(i)
	    	   ->GetObject <Ipv4>()
	    	   ->GetAddress (1, 0).GetLocal ();

	  x = nodes.Get(i)->GetObject<ConstantPositionMobilityModel>()
			          ->GetPosition().x;
	  y = nodes.Get(i)->GetObject<ConstantPositionMobilityModel>()
			          ->GetPosition().y;
	  *stream->GetStream()<<i+1<<" "<<nodeIp<<" "<<(int)x<<" "<<(int)y <<"\n";

	}
  *stream->GetStream()<<std::endl;
}




int main (int argc, char **argv)
{
  TraceRouteExample test;
  if (!test.Configure (argc, argv))
    NS_FATAL_ERROR ("Configuration failed. Aborted.");

  test.Run ();
  test.Report (std::cout);
  return 0;
}



